
program = require 'commander'
color = require('ansi-color').set
exec = require('child_process').exec
yaml = require 'yaml'
fs = require 'fs'


supported_databases = [ 'redis', 'mongo' ]


program
  .version('0.0.4')
  .option('-c, --config [type]', 'Specify a config file')
  .option('-d, --database [type]', 'Add the specified database',)
  .option('-f, --folder [type]', 'Destination folder/directory')
  .option('-x,  --dump-config', 'Dump the default config file')
  .parse(process.argv)


puts = (error, stdout, stderr) -> 
  if stdout
    console.log color '  - '+stdout, 'green' 
  if stderr
    console.log color '  - '+stderr, 'red'


config = yaml.eval( 
         fs.readFileSync(__dirname+'/config.yaml')
         .toString('utf-8')
         )

#console.log config

fs.readdir('.' , (err,files) -> 
  #console.log files
)

if program.folder
   # console.log color 'Building to: ' + process.cwd() + '/' + program.folder, 'white' 
else
  program.folder = ''

if program.folder != ''
  dir =  process.cwd() + '/' + program.folder + '/'
else
  dir = process.cwd()


if program.dumpConfig
  process.stdout.write color 'Redux -> ', 'magenta+bold'
  process.stdout.write color 'dumping config file...', 'white'
  exec 'cp -f ' + __dirname + '/config.yaml* ' + dir, puts
  process.stdout.write color '...done!\n',  'green+bold'
  process.exit(0) 


if program.config 
  console.log color 'Using custom configuration file: ' + program.config, 'yellow'
  config = yaml.eval( 
         fs.readFileSync(process.cwd() + '/' + program.config)
         .toString('utf-8')
         )

else
  console.log color 'No config file specified, using defaults', 'white'

if program.database 
  console.log '  - database'
else if config.database.driver

    if config.database.type != ' ' ||  config.database.type in supported_databases
      
      process.stdout.write color '[config] ', 'green'
      console.log color 'using database: ' + config.database.type, 'white'

    else
      console.log color 'Database: ' + config.database.type + ' not supported', 'red'
 
else
  console.log color 'No database specified, skipping...', 'yellow'

console.log color 'Redux is building...\n', 'magenta+bold'

changeto = (error, stdout, stderr) ->
  
  process.chdir(dir)
  
  exec 'cp -rf ' + __dirname + '/res/* ' + dir, puts

  console.log color '\nBuilding out skeleton to: ', 'magenta'
  console.log color '    '  + dir, 'green'

  console.log color '\nInstalling NPM dependencies.....', 'magenta+bold'

  exec 'npm install', (error, stdout, stderr) -> 
    if stdout
      console.log color '  - '+stdout, 'white' 
    if stderr
      console.log color '  - '+stderr, 'red'
  
    console.log color '\nDone! run: node app.js', 'magenta+bold'


exec 'mkdir -p ' + dir, changeto






