fs = require 'fs'
connect = require 'connect'
express = require 'express'
jade = require 'jade'
stylus = require 'stylus'
color = require('ansi-color').set
yaml = require 'yaml'

app = module.exports = express.createServer()

# CONFIGURATION

config = yaml.eval(
        fs .readFileSync(__dirname+'/config.yaml')
           .toString('utf-8')
        );


app.configure(() ->
  app.set 'view engine', 'jade'
  app.set 'views', "#{__dirname}/templates"

  app.use stylus.middleware({
        src: __dirname + "/templates/includes",
        dest: __dirname + "/static",
        compile: compileMethod
  }) 

  compileMethod = (str) ->
    return stylus(str).set('compress', true)

  app.use connect.bodyParser()
  app.use express.cookieParser()
  app.use express.session({secret : "shhhhhhhhhhhhhh!"})
  app.use express.logger()
  app.use express.methodOverride()
  app.use app.router

  app.use connect.static(__dirname + '/static')
)

app.configure 'development', () ->
	app.use express.errorHandler({
		dumpExceptions: true
		showStack     : true
	})

app.configure 'production', () ->
	app.use express.errorHandler()

# ROUTES

app.get '/', (req, res) ->
	res.render 'layout',
		locals:
			title: 'Hello World!'

# SERVER

app.listen config.server.port
console.log color "[ Express.js ] server listening on port #{app.address().port}...\n", 'green'
